// C Source File
// Created 11/6/01; 9:30:54 PM


/*
////////////////////////////////////////////////////////////////////////
																		SPRITE MAKER
																		BY TY TAYLOR

										This source requires the extgraph header from
																tict.ticalc.org
/////////////////////////////////////////////////////////////////////////
*/

#define USE_TI89              // Produce .89z File

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

#include "extgraph.h"


#define MAX_SPRITES 35

unsigned short pblock=0;	//sprite whose value changes depending on width,  see the setblock function



int spritevalue(unsigned long *sprite,int x, int y)
{
	unsigned long mask=0x80000000;
//	return *(sprite+y)&(mask>>x);
	
	if(*(sprite+y)&(mask>>x))
	return TRUE;
	return FALSE;
}

void putinsprite(unsigned long *sprite,int x, int y, int value)
{
	unsigned long mask=0x80000000;
	mask=mask>>x;
	sprite+=y;

//puts 1 in that bit
if(value==1)
	*(sprite)|=mask;

//puts 0 in that bit	
if(value==0)
	*(sprite)&=~mask;
}


	void drawgrayline(int x1,int y1,int x2,int y2,int mode,int color)
	{
		if(color==4||color==8) FastDrawLine(GetPlane(1),x1,y1,x2,y2,mode);
		if(color==2||color==8) FastDrawLine(GetPlane(0),x1,y1,x2,y2,mode);
	}


	void drawmarker(int x, int y, int incx, int incy)
	{
			drawgrayline(x*incx,y*incy,x*incx+incx-1,y*incy+incy-1,2,8);
			drawgrayline(x*incx+incx-1,y*incy,x*incx,y*incy+incy-1,2,8);	
	}



/*
//ANDS the one line sprite to multiple lines on the screen
void Sprite16_ONEAND(short x,short y,short h,unsigned short* sprite,void* dest) {
    register long            addr = (long)dest+(y<<5)-(y<<1)+((x>>3)&0xfffe);
    register unsigned short  cnt  = 16-(x&15);
    for (;h;h--,addr+=30) 
    {
    *(long*)addr&=~(long)((*sprite) & 0xffff)<<cnt;	
    }
}
*/

//ORS the one pblock to multiple lines on the screen
void Sprite16_ONE(short x,short y,short h,void* dest) {
    register long            addr = (long)dest+(y<<5)-(y<<1)+((x>>3)&0xfffe);
    register unsigned short  cnt  = 16-(x&15);
    for (;h;h--,addr+=30) 
    {
		*(long*)addr|=(long)((pblock) & 0xffff)<<cnt;	
    }
}


void drawpixel(int x, int y, int incx,int incy, int color)
{
if(color==4||color==6)  Sprite16_ONE(x*incx,y*incy,incy,GetPlane(1));
if(color==2||color==6)  Sprite16_ONE(x*incx,y*incy,incy,GetPlane(0));
}

/*
void drawpixel2(int x, int y, int incx,int incy, int color)
{
if(color==4||color==6)  Sprite16_ONE(x*incx,y*incy,incy,pblock,GetPlane(1));
else	Sprite16_ONEAND(x*incx,y*incy,incy,pblock,GetPlane(1));
if(color==2||color==6)  Sprite16_ONE(x*incx,y*incy,incy,pblock,GetPlane(0));
else	Sprite16_ONEAND(x*incx,y*incy,incy,pblock,GetPlane(0));
}
*/


void drawerline(int x0, int y0, int x1, int y1, int color, int incx, int incy, int effect, unsigned long *sprite)
{
	int i;
	int my=y1-y0;
	int mx=x1-x0;
	int xv=0;
	int yv=0;
	
	//don't wanna crash it
	if(mx==0&&my==0) return;

	//it looks nasty, but it should work
	for(i=0; abs(mx)<abs(my) ? (y0<y1 ? i<=y1-y0 : i<=y0-y1) : (x0<x1 ? i<=x1-x0 : i<=x0-x1); i++)
{
	xv=(abs(mx)>=abs(my) ? (x0<x1 ? i+x0 : i+x1) : (y0<y1 ? i*mx/my+x0 : i*mx/my+x1));
	yv=(abs(mx)>=abs(my) ? (x0<x1 ? i*my/mx+y0 : i*my/mx+y1) : (y0<y1 ? i+y0 : i+y1));
	
	if(effect==0)
	drawpixel(xv,yv,incx,incy,color);
	else
	{
	putinsprite(sprite,xv,yv,color/4);
	putinsprite(sprite+100,xv,yv,(color==2||color==6)?1:0);
	}

	
}









}





void drawint(int num,int x, int y)
{
	char temp[15];
	sprintf(temp,"%d",num);
	DrawStr(x,y,temp,2);
}

int changenum(int *num, int x, int y)
	{
		int key;
		char temp1[15];
		
		DrawStr(x-8,y,">",4);
		do
		{
		key=ngetchx();
			
			if(key>='0'&&key<='9'&& *(num) < 10000)
			{
				*(num)*=10; 
				*(num)+=key-48;			
			}
			
			if(key== KEY_BACKSPACE)
			{
				*(num)/=10;
			}
			
				sprintf(temp1,"%d   ",*(num));
				DrawStr(x,y,temp1,4);
		
			
			
		}while(key!=264&&key!=13);
		DrawStr(x-8,y," ",4);
	return key;
		
	}


void InputStr (char *buffer, short maxlen, int x, int y)
{
  SCR_STATE ss;
  short i = strlen(buffer),key;
  char str[15];
  buffer[i] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      sprintf (str,"%s_  ", buffer);
      DrawStr(x,y,str,4);
        // Note that two spaces are required if F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen) buffer[i++] = key;
      if (key == KEY_BACKSPACE && i) i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER&&key!=264);
}


	//set block sprite
void setblock(int incx){
	
int i;
	pblock=0;
for(i=0;i<incx;i++)
{
	pblock+=0x8000>>i;
}
}



// Main Function
void _main(void)
{
	int x=0,y=0,swidth=16,sheight=16,incy=6,incx=6,graymode=1,redraw=1,color=0,spritenum=1,cs=0;
	int i,j=0,k,l,m=0,n=0;
	void *kbq = kbd_queue ();
	
	unsigned int key=0;
	//char drawer[5]={0/*mode*/,0/*x1*/,0/*y1*/,0/*x2*/,0/*y2*/};
	
	char name[10]="";
	char temp=0;
	
	unsigned long (*sprite)[2][100]=NULL;
	unsigned long tsprite[100]={};	

	unsigned long copysprite[2][100]={};
	
	int drawer[3]={};//type,xstart,ystart
	
	FILE *f;
	char TIOSname[12];
	HSym hsym;
	
	
	clrscr();
	
	sprite = calloc (MAX_SPRITES, sizeof(*sprite));
	
	
	GrayOn();
	
	ClearGrayScreen();
	
	
	
	
	incy=100/sheight;
	incx=100/swidth;

setblock(incx);

/*	
	for(i=0;i<=swidth*inc;i+=inc)
	{
		if(i<99)
		DrawGrayLine(0,i,swidth*inc,i,8);
		
		DrawGrayLine(i,0,i,sheight*inc,8);		
	}
*/	
FontSetSys(0);

	

	
	
	

	
	do{

	drawmarker(x,y,incx,incy);
	
		//save file
if(key=='3')
{
redraw=1;

DrawStr(102,sheight+40,"Save name?",2);
InputStr(name,8,112,sheight+46);


//unarchive it
		TIOSname[0] = 0;	
		hsym = SymFind (strcpy (TIOSname + 1, name) + strlen (name));
		EM_moveSymFromExtMem (NULL, hsym); 


f=fopen(name,"wt");

if(swidth>16) m=32;
if(swidth<=16&&swidth>8) m=16;
if(swidth<=8) m=8;

for(n=0;n<spritenum;n++){
	
fputc('{',f);
for(l=0;l<=graymode;l++){
for(j=0;j<sheight;j++){
	fputs("0x",f);
	for(i=0;i<m;i+=4)
	{
		k=spritevalue(sprite[n][l],i+3,j);
		k+=2*spritevalue(sprite[n][l],i+2,j);
		k+=4*spritevalue(sprite[n][l],i+1,j);
		k+=8*spritevalue(sprite[n][l],i,j);


//turns decimal to hexadecimal
	if(k<10) temp=(char)k+48;
	else	temp=(char)k+55;

	fputc(temp,f);	
	}
if(j==sheight-1&&l==graymode) fputc('}',f);
fputc(',',f);
}	
}
fputc('\n',f);

}

fclose(f);

//archive it
		hsym = SymFind (strcpy (TIOSname + 1, name) + strlen (name));
		EM_moveSymToExtMem (NULL, hsym); 


}



		//load file
if(key=='4')
{
redraw=1;


DrawStr(102,sheight+40,"Load name?",2);
InputStr(name,8,112,sheight+46);

memset(sprite[0][0],0,20*4*200);

if((f=fopen(name,"rt"))){

	while((temp=fgetc(f))!=EOF&&temp!='x');



i=0;
	while((temp=fgetc(f))!=EOF&&temp!=',')
	{
		i++;
	}

swidth=i*4;

cs=0;

i=2;
	while((temp=fgetc(f))!='}'&&temp!=EOF)
	{
		if(temp==',') i++;
	}

sheight=i/(graymode+1);




	incy=100/sheight;
	incx=100/swidth;


setblock(incx);

rewind(f);

n=0;

while(fgetc(f)!=EOF){
for(l=0;l<=graymode;l++){


for(j=0;j<sheight;j++){
	
	while((temp=fgetc(f))!=EOF&&temp!='x');

	for(i=0;i<swidth;i+=4)
	{
	if((temp=fgetc(f))==EOF) break;	
	
//turns hex value to decimal
	if((int)temp<58) k=(int)temp-48;
	else	k=(int)temp-55;

	
	
	if(k>7){	putinsprite(sprite[n][l],i,j,1); k-=8;}
	if(k>3){	putinsprite(sprite[n][l],i+1,j,1); k-=4;}
	if(k>1){	putinsprite(sprite[n][l],i+2,j,1); k-=2;}
	if(k>0){	putinsprite(sprite[n][l],i+3,j,1);}
	
	}


}	

}
n++;
}
spritenum=n-1;

fclose(f);
}	
}
	

//help
if(key==KEY_F5)
{
	ClearGrayScreen();
	redraw=1;
	printf("X: Black   Y: Dark Gray   Z: Light Gray  T:White\n
3: Save   4: Load\n
F1: Line   F2: Rectangle  F3:  Filled rect\n
= : Invert   ( : Vertical flip   ) : Horizontal flip\n
, : Rotate   Copy   Cut   Paste\n
CLEAR: Change # of sprites   <- : View all\n
+ : Next Sprite   - : Previous Sprite\n
<> + arrow : translate    . : animate");

ngetchx();

}


//animate
if(key=='.')
{
	ClearGrayScreen();
	redraw=1;

	i=0;
	j=0;
	k=spritenum-1;
	l=25;
	
	DrawStr(0,0,"Start Pic (F1)",2);
	drawint(j,20,10);
	
	DrawStr(60,0,"End Pic (F2)",2);
	drawint(k,70,10);
	
	DrawStr(120,0,"Speed (F3)",2);
	drawint(l,130,10);
	
	DrawStr(0,90,"Exit (F5)",2);
	
	
	GraySprite32_XOR(80-swidth/2,50-sheight/2,sheight,sprite[i][0],sprite[i][graymode],GetPlane(1),GetPlane(0));

	do{
	GraySprite32_XOR(80-swidth/2,50-sheight/2,sheight,sprite[i][0],sprite[i][graymode],GetPlane(1),GetPlane(0));
	
	i++;
	if(i>k) i=j;

	GraySprite32_XOR(80-swidth/2,50-sheight/2,sheight,sprite[i][0],sprite[i][graymode],GetPlane(1),GetPlane(0));


for(m=l*100;m>0;m--)
{
	for(n=0;n<30000;n++);
}

	
		if (!OSdequeue (&key, kbq))
  {
    if(key==KEY_F1) changenum(&j,20,10);
    if(key==KEY_F2) changenum(&k,70,10);
    if(key==KEY_F3) changenum(&l,130,10);
    if(key==KEY_F5) j=100;
    
    if(k>spritenum-1) k=spritenum-1;
    if(l>300) l=30;
	}
	
		
		
	}while(j<100);
	
	key='.';
	
}




if(key==16722){	//diamond + left
	for(j=0;j<=graymode;j++){
	for(i=0;i<sheight;i++)
	{
		k=spritevalue(sprite[cs][j],0,i);
		sprite[cs][j][i]<<=1;
		putinsprite(sprite[cs][j],swidth-1,i,k);
	}
	}	
redraw=1;
}

if(key==16728){	//diamond + right
	for(j=0;j<=graymode;j++){
	for(i=0;i<sheight;i++)
	{
		k=spritevalue(sprite[cs][j],swidth-1,i);
		sprite[cs][j][i]>>=1;
		putinsprite(sprite[cs][j],0,i,k);
		putinsprite(sprite[cs][j],swidth,i,0);
	}
	}	
redraw=1;
}

if(key==16721){	//diamond + up
	for(j=0;j<=graymode;j++){
		tsprite[0]=sprite[cs][j][0];
	for(i=0;i<sheight-1;i++)
	{
		sprite[cs][j][i]=sprite[cs][j][i+1];
	}
	sprite[cs][j][sheight-1]=tsprite[0];
	}	
redraw=1;
}

if(key==16724){	//diamond + down
	for(j=0;j<=graymode;j++){
		tsprite[0]=sprite[cs][j][sheight-1];
	for(i=sheight-1;i>0;i--)
	{
		sprite[cs][j][i]=sprite[cs][j][i-1];
	}
	sprite[cs][j][0]=tsprite[0];
	}	
redraw=1;
}







//copy
if(key==24576)
{
	for(i=0;i<=graymode;i++){
	for(j=0;j<sheight;j++)
	{
		copysprite[i][j]=sprite[cs][i][j];
	}
	}
}

//cut
if(key==20480)
{
	for(i=0;i<=graymode;i++){
	for(j=0;j<sheight;j++)
	{
		copysprite[i][j]=sprite[cs][i][j];
		sprite[cs][i][j]=0;
	}
	}
redraw=1;	
}

//paste
if(key==16648)
{
	for(i=0;i<=graymode;i++){
	for(j=0;j<sheight;j++)
	{
		sprite[cs][i][j]=copysprite[i][j];
	}
	}
	redraw=1;
}



//vertical flip
if(key=='(')
{
	redraw=1;

	for(i=0;i<=graymode;i++){
	for(j=0;j<sheight;j++)
	{
		tsprite[sheight-j-1]=sprite[cs][i][j];
	}
	memmove(&sprite[cs][i][0],&tsprite[0],4*sheight);
	}
	
}

//invert
if(key=='=')
{
	redraw=1;

	for(i=0;i<=graymode;i++)
	{
		for(j=0;j<sheight;j++)
		{
			sprite[cs][i][j]=~sprite[cs][i][j];
		}
	}
	
}


//horizontal flip
if(key==')')
{
	redraw=1;


	for(i=0;i<=graymode;i++)
	{
		for(j=0;j<sheight;j++)
		{
			for(k=0;k<swidth/2;k++)
			{
				tsprite[0]=spritevalue(&sprite[cs][i][0],swidth/2+k,j);
				putinsprite(&sprite[cs][i][0],swidth/2+k,j,spritevalue(&sprite[cs][i][0],swidth/2-k-1,j));
				putinsprite(&sprite[cs][i][0],swidth/2-k-1,j,tsprite[0]);
			}
		}
	}
	
}


//rotate 90 degree
if(key==','&&swidth==sheight)
{
	redraw=1;
	

	for(i=0;i<=graymode;i++)
	{

memmove(tsprite,sprite[cs][i],4*sheight);

		for(j=0;j<sheight;j++)
		{
			for(k=0;k<swidth;k++)
			{
				putinsprite(&sprite[cs][i][0],k,j,spritevalue(&tsprite[0],j,swidth-1-k));
			}
		}
	}	
}




	//change gray mode
	if(key==KEY_MODE)
	{
		switch(graymode)
		{
			case 0: graymode=1; break;
			case 1: graymode=0; break;
		}
	redraw=1;		
	}
	
	
	//change width
	if(key==KEY_APPS)
	{
	changenum(&swidth,150,sheight+14);
	redraw=1;
	
	if(swidth>32) swidth=32;
	
	incx=100/swidth;

setblock(incx);

	}

	//change heigth
	if(key==278)	//CATALOG
	{
	changenum(&sheight,150,sheight+22);
	redraw=1;
	
	if(sheight>100) sheight=100;

		incy=100/sheight;
	}

	//change # of sprites
	if(key==263)	//CLEAR
	{
	DrawStr(100,sheight+40,"# of sprites:",2);
	drawint(spritenum,150,sheight+40);
	changenum(&spritenum,150,sheight+40);
	redraw=1;
	
	if(spritenum>MAX_SPRITES) spritenum=MAX_SPRITES;
	}

	if(key=='-'&&cs>0)
	{
		redraw=1;
		cs--;
	}
	if(key=='+'&&cs<spritenum-1)
	{
		redraw=1;
		cs++;
	}



		
	if(key==KEY_LEFT) x--;
	if(key==KEY_RIGHT) x++;
	if(key==KEY_UP) y--;
	if(key==KEY_DOWN) y++;
	
	//move marker quicker with 2nd+arrow
	if(key==4433) y-=sheight/5;
	if(key==4436) y+=sheight/5;
	if(key==4434) x-=swidth/5;
	if(key==4440) x+=swidth/5;

	if(x<0) x=0;
	if(x>swidth-1) x=swidth-1;
	if(y<0) y=0;
	if(y>sheight-1) y=sheight-1;

	

	if(key>='t'&&key<='z')
	{
		redraw=1;
		i=0;
		j=0;
		switch(key)
		{
			case 'z': //light gray
			j=1;
			break;
			case 'y': //dark gray
			i=1;
			break;
			case 'x': //black
			i=1;
			j=1;
			break;
		}
		color=4*i+2*j;
	putinsprite(sprite[cs][0],x,y,i);
	putinsprite(sprite[cs][1],x,y,j);
			
	}
		


//special draweres
if(key>=KEY_F1&&key<=KEY_F3)
{
	if(drawer[0]==0){
	drawer[0]=key;
	drawer[1]=x;
	drawer[2]=y;
	}
else
{
	drawer[0]=0;		
	redraw=1;
switch(key)
{
	case KEY_F1:
		drawerline(drawer[1],drawer[2],x,y,color,incx,incy,1,sprite[cs][0]);	//draw line
	break;
	case KEY_F2:	//rectangel
		drawerline(drawer[1],drawer[2],drawer[1],y,color,incx,incy,1,sprite[cs][0]);
		drawerline(drawer[1],drawer[2],x,drawer[2],color,incx,incy,1,sprite[cs][0]);
		drawerline(drawer[1],y,x,y,color,incx,incy,1,sprite[cs][0]);
		drawerline(x,drawer[2],x,y,color,incx,incy,1,sprite[cs][0]);	
	break;
	case KEY_F3:	//filled rectangle
		for(drawer[2]<y?(i=drawer[2]):(i=y);drawer[2]<y?(i<=y):(i<=drawer[2]);i++)
	{
		drawerline(drawer[1],i,x,i,color,incx,incy,1,sprite[cs][0]);	
	}
	break;
}
}
	
}



if(key==KEY_BACKSPACE)
{
	ClearGrayScreen();
	n=0;
		for(j=0;j<96&&n<spritenum;j+=sheight)
		{
			for(i=0;i<161-swidth&&n<spritenum;i+=swidth,n++)
			{
					GraySprite32_XOR(i,j,sheight,sprite[n][0],sprite[n][graymode],GetPlane(1),GetPlane(0));
			}
		}
	ngetchx();
	redraw=1;
}



//redraws the whole screen
if(redraw==1||drawer[0]>0){
	
	ClearGrayScreen();
	
	
redraw=0;	
		drawgrayline(0,sheight*incy,swidth*incx,sheight*incy,2,8);		
		drawgrayline(swidth*incx,0,swidth*incx,sheight*incy,2,8);		
	
		for(j=0;j<sheight;j++)
	{
		for(i=0;i<swidth;i++)
		{
if(graymode)
k=4*spritevalue(sprite[cs][0],i,j)+2*spritevalue(sprite[cs][1],i,j);
else
k=6*spritevalue(sprite[cs][0],i,j);

drawpixel(i,j,incx,incy,k);
		}
	}
	
	//drawer lines
	if(drawer[0]==KEY_F1)	drawerline(drawer[1],drawer[2],x,y,color,incx,incy,0,sprite[cs][0]);
		
	if(drawer[0]==KEY_F2)
	{
		drawerline(drawer[1],drawer[2],drawer[1],y,color,incx,incy,0,sprite[cs][0]);
		drawerline(drawer[1],drawer[2],x,drawer[2],color,incx,incy,0,sprite[cs][0]);
		drawerline(drawer[1],y,x,y,color,incx,incy,0,sprite[cs][0]);
		drawerline(x,drawer[2],x,y,color,incx,incy,0,sprite[cs][0]);
	}

	if(drawer[0]==KEY_F3)
	{
	for(drawer[2]<y?(i=drawer[2]):(i=y);drawer[2]<y?(i<=y):(i<=drawer[2]);i++)
{
		drawerline(drawer[1],i,x,i,color,incx,incy,0,sprite[cs][0]);	
}
	}



	
	GraySprite32_XOR(100,0,sheight,sprite[cs][0],sprite[cs][graymode],GetPlane(1),GetPlane(0));
	
	DrawStr(105+swidth,0,"By Ty",2);
	DrawStr(105+swidth,6,"Taylor",2);

//	DrawStr(100+swidth,6,"tnt@calcware.org",2);


	DrawStr(100,sheight+6,"(MODE)Gray:",2);
	if(graymode==0)  	DrawStr(150,sheight+6,"Off",2);
	else  	DrawStr(150,sheight+6,"On",2);

	DrawStr(100,sheight+14,"(APPS)Width:",2);
	drawint(swidth,150,sheight+14);
	
	DrawStr(100,sheight+22,"(CAT)Height:",2);
	drawint(sheight,150,sheight+22);

	DrawStr(100,sheight+30,"Sprite:",2);
	drawint(cs,150,sheight+30);


	DrawStr(100,sheight+55,"F5: Help",2);




}	

	
	drawmarker(x,y,incx,incy);		
	
	
	
		
	}while((key=ngetchx())!=KEY_ESC);
	
	
	free(sprite);
	

	
	GrayOff();
	
	FontSetSys(1);

	
	
}
